function H = HessianMatrix12(X, Y, Ix, Iy)
    H = zeros(12,12);
    
    Ix2 = Ix.^2;
    IxIy = Ix .* Iy;
    Iy2 = Iy.^2;
       
    H(1,1) = sum(sum(Ix2));
    H(1,2) = sum(sum(X .* Ix2));
    H(1,3) = sum(sum(Y .* Ix2));
    H(1,4) = 0.5 * sum(sum(X.^2 .* Ix2));
    H(1,5) = sum(sum(X .* Y .* Ix2));
    H(1,6) = 0.5 * sum(sum(Y.^2 .* Ix2));
    H(1,7) = sum(sum(IxIy));
    H(1,8) = sum(sum(X .* IxIy));
    H(1,9) = sum(sum(Y .* IxIy));
    H(1,10) = 0.5 * sum(sum(X.^2 .* IxIy));
    H(1,11) = sum(sum(X .* Y .* IxIy));
    H(1,12) = 0.5 * sum(sum(Y.^2 .* IxIy));

    H(2,1) = H(1,2);
    H(2,2) = sum(sum(X.^2 .* Ix2));
    H(2,3) = sum(sum(X .* Y .* Ix2));
    H(2,4) = 0.5 * sum(sum(X.^3 .* Ix2));
    H(2,5) = sum(sum(X.^2 .* Y .* Ix2));
    H(2,6) = 0.5 * sum(sum(X .* Y.^2 .* Ix2));
    H(2,7) = sum(sum(X .* IxIy));
    H(2,8) = sum(sum(X.^2 .* IxIy));
    H(2,9) = sum(sum(X .* Y .* IxIy));
    H(2,10) = 0.5 * sum(sum(X.^3 .* IxIy));
    H(2,11) = sum(sum(X.^2 .* Y .* IxIy));
    H(2,12) = 0.5 * sum(sum(X .* Y.^2 .* IxIy));

    H(3,1) = H(1,3);
    H(3,2) = H(2,3);
    H(3,3) = sum(sum(Y.^2 .* Ix2));
    H(3,4) = 0.5 * sum(sum(X.^2 .* Y .* Ix2));
    H(3,5) = sum(sum(X .* Y.^2 .* Ix2));
    H(3,6) = 0.5 * sum(sum(Y.^3 .* Ix2));
    H(3,7) = sum(sum(Y .* IxIy));
    H(3,8) = sum(sum(X .* Y .* IxIy));
    H(3,9) = sum(sum(Y.^2 .* IxIy));
    H(3,10) = 0.5 * sum(sum(X.^2 .* Y .* IxIy));
    H(3,11) = sum(sum(X .* Y.^2 .* IxIy));
    H(3,12) = 0.5 * sum(sum(Y.^3 .* IxIy));

    H(4,1) = H(1,4);
    H(4,2) = H(2,4);
    H(4,3) = H(3,4);
    H(4,4) = 0.25 * sum(sum(X.^4 .* Ix2));
    H(4,5) = 0.5 * sum(sum(X.^3 .* Y .* Ix2));
    H(4,6) = 0.25 * sum(sum(X.^2 .* Y.^2 .* Ix2));
    H(4,7) = 0.5 * sum(sum(X.^2 .* IxIy));
    H(4,8) = 0.5 * sum(sum(X.^3 .* IxIy));
    H(4,9) = 0.5 * sum(sum(X.^2 .* Y .* IxIy));
    H(4,10) = 0.25 * sum(sum(X.^4 .* IxIy));
    H(4,11) = 0.5 * sum(sum(X.^3 .* Y .* IxIy));
    H(4,12) = 0.25 * sum(sum(X.^2 .* Y.^2 .* IxIy));

    H(5,1) = H(1,5);
    H(5,2) = H(2,5);
    H(5,3) = H(3,5);
    H(5,4) = H(4,5);
    H(5,5) = sum(sum(X.^2 .* Y.^2 .* Ix2));
    H(5,6) = 0.5 * sum(sum(X .* Y.^3 .* Ix2));
    H(5,7) = sum(sum(X .* Y .* IxIy));
    H(5,8) = sum(sum(X.^2 .* Y .* IxIy));
    H(5,9) = sum(sum(X .* Y.^2 .* IxIy));
    H(5,10) = 0.5 * sum(sum(X.^3 .* Y .* IxIy));
    H(5,11) = sum(sum(X.^2 .* Y.^2 .* IxIy));
    H(5,12) = 0.5 * sum(sum(X .* Y.^3 .* IxIy));

    H(6,1) = H(1,6);
    H(6,2) = H(2,6);
    H(6,3) = H(3,6);
    H(6,4) = H(4,6);
    H(6,5) = H(5,6);
    H(6,6) = 0.25 * sum(sum(Y.^4 .* Ix2));
    H(6,7) = 0.5 * sum(sum(Y.^2 .* IxIy));
    H(6,8) = 0.5 * sum(sum(X .* Y.^2 .* IxIy));
    H(6,9) = 0.5 * sum(sum(Y.^3 .* IxIy));
    H(6,10) = 0.25 * sum(sum(X.^2 .* Y.^2 .* IxIy));
    H(6,11) = 0.5 * sum(sum(X .* Y.^3 .* IxIy));
    H(6,12) = 0.25 * sum(sum(Y.^4 .* IxIy));
    
    H(7,1) = H(1,7);
    H(7,2) = H(2,7);
    H(7,3) = H(3,7);
    H(7,4) = H(4,7);
    H(7,5) = H(5,7);
    H(7,6) = H(6,7);
    H(7,7) = sum(sum(Iy2));
    H(7,8) = sum(sum(X .* Iy2));
    H(7,9) = sum(sum(Y .* Iy2));
    H(7,10) = 0.5 * sum(sum(X.^2 .* Iy2));
    H(7,11) = sum(sum(X .* Y .* Iy2));
    H(7,12) = 0.5 * sum(sum(Y.^2 .* Iy2));
    
    H(8,1) = H(1,8);
    H(8,2) = H(2,8);
    H(8,3) = H(3,8);
    H(8,4) = H(4,8);
    H(8,5) = H(5,8);
    H(8,6) = H(6,8);
    H(8,7) = H(7,8);
    H(8,8) = sum(sum(X.^2 .* Iy2));
    H(8,9) = sum(sum(X .* Y .* Iy2));
    H(8,10) = 0.5 * sum(sum(X.^3 .* Iy2));
    H(8,11) = sum(sum(X.^2 .* Y .* Iy2));
    H(8,12) = 0.5 * sum(sum(X .* Y.^2 .* Iy2));
    
    H(9,1) = H(1,9);
    H(9,2) = H(2,9);
    H(9,3) = H(3,9);
    H(9,4) = H(4,9);
    H(9,5) = H(5,9);
    H(9,6) = H(6,9);
    H(9,7) = H(7,9);
    H(9,8) = H(8,9);
    H(9,9) = sum(sum(Y.^2 .* Iy2));
    H(9,10) = 0.5 * sum(sum(X.^2 .* Y .* Iy2));
    H(9,11) = sum(sum(X .* Y.^2 .* Iy2));
    H(9,12) = 0.5 * sum(sum(Y.^3 .* Iy2));
    
    H(10,1) = H(1,10);
    H(10,2) = H(2,10);
    H(10,3) = H(3,10);
    H(10,4) = H(4,10);
    H(10,5) = H(5,10);
    H(10,6) = H(6,10);
    H(10,7) = H(7,10);
    H(10,8) = H(8,10);
    H(10,9) = H(9,10);
    H(10,10) = 0.25 * sum(sum(X.^4 .* Iy2));
    H(10,11) = 0.5 * sum(sum(X.^3 .* Y .* Iy2));
    H(10,12) = 0.25 * sum(sum(X.^2 .* Y.^2 .* Iy2));
    
    H(11,1) = H(1,11);
    H(11,2) = H(2,11);
    H(11,3) = H(3,11);
    H(11,4) = H(4,11);
    H(11,5) = H(5,11);
    H(11,6) = H(6,11);
    H(11,7) = H(7,11);
    H(11,8) = H(8,11);
    H(11,9) = H(9,11);
    H(11,10) = H(10,11);
    H(11,11) = sum(sum(X.^2 .* Y.^2 .* Iy2));
    H(11,12) = 0.5 * sum(sum(X .* Y.^3 .* Iy2));
    
        
    H(12,1) = H(1,12);
    H(12,2) = H(2,12);
    H(12,3) = H(3,12);
    H(12,4) = H(4,12);
    H(12,5) = H(5,12);
    H(12,6) = H(6,12);
    H(12,7) = H(7,12);
    H(12,8) = H(8,12);
    H(12,9) = H(9,12);
    H(12,10) = H(10,12);
    H(12,11) = H(11,12);
    H(12,12) = 0.25 * sum(sum(Y.^4 .* Iy2));
end

